您的位置:首页 > 其它

广搜 BFS POJ 3126 Prime Path

2016-07-28 17:30 423 查看
Description


The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 

— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 

— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 

— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 

— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 

— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 

— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 

— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 

— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 

— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033

1733

3733

3739

3779

8779

8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.
Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).
Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.
Sample Input
3
1033 8179
1373 8017
1033 1033

Sample Output

6

7

0

AC代码

#include<iostream>
#include<queue>
#include<cmath>
#include<cstring>
using namespace std;
queue<int> num;
int a,b,w[4],v[4],change[10010],vis[10010]; //w,v数组用于存改变后和改变前四位数的数字
bool isp[10010];                                           //生成素数表提高判断素数效率
bool ispreme(int q)
{
    int m=sqrt(q);
    for(int i=2;i<=m;i++)
        if(q%i==0)
            return false;
    return true;
}
void bfs()
{
    num.push(a);
    vis[a]=1;
    while(!num.empty()){
        int u=num.front();
        int temp=u;
        for(int i=0;i<4;i++){                                    //更新改变后的四位数
            w[i]=temp%10;
            temp/=10;
        }                                                             
        num.pop();
        int i,j;
        for(i=0;i<4;i++){                                         //对四个位置分别改变一个数字
            if(i!=3) j=0;                                            //千位从1开始,其他从0开始替换
            else j=1;
            for(;j<10;j++){
                int bk=u-w[i]*pow(10,i)+j*pow(10,i);
                if(j!=w[i]&&isp[bk]&&!vis[bk]){
                    num.push(bk);
                    vis[bk]=1;
                    change[bk]=change[u]+1;
                    if(bk==b)
                        return;
                }
            }
        }
    }
}
int main()
{
    int n;
    for(int i=1000;i<10010;i++)
        isp[i]=ispreme(i);
    cin>>n;
    while(n--){
        cin>>a>>b;
        if(a==b){
            cout<<0<<endl;
            continue;
        }
        while(!num.empty()) num.pop();                                  //初始化
        memset(change,0,sizeof(change));
        memset(vis,0,sizeof(vis));
        int temp=b;
        for(int i=0;i<4;i++){                                                      //存储改变前的四位数字
            v[i]=temp%10;
            temp/=10;
        }
        bfs();
        cout<<change[b]<<endl;
    }
    return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: